userRoutine: \\(){

	// O̕oĂ / Remember the previous direction
	CALL	SW_API_GetSnakeDir
	LD	(PREV_DIR),A
	// ݁A̕ϐ͎gpĂ܂B ϐ̒`@߂ɏĂ܂B
	// Currently this variable is not used. This is written to show how to define variables.

	//----------------------------
	// Փˉ / Avoid collision 
	//----------------------------
	LD	A,0
	CALL	common_checkSafe
	IF	NC
		CALL	common_turnRightSafety
		IF	NC
			CALL	common_turnLeftSafety
		ENDIF
	ELSE
		//-----------------------------------------------
		// GT֕̕] / Change direction to food 
		//-----------------------------------------------
		CALL	SW_API_GetSnakePos
		LD	DE,BC
		CALL	SW_API_GetTargetPos

		// XWvH / X coordinate match?
		LD	A,D
		IF	A == B
			CALL	SW_API_GetSnakeDir
			// is4H / Is the direction 4?
			IF	A == 4
				// GTɂH / Is it below the food?
				LD	A,E
				IF	A >= C
					CALL	common_turnRightSafety
				ELSE
					CALL	common_turnLeftSafety
				ENDIF
			// is6H / Is the direction 6?
			ELSEIF	A == 6
				// GTɂH / Is it below the food?
				LD	A,E
				IF	A >= C
					CALL	common_turnLeftSafety
				ELSE
					CALL	common_turnRightSafety
				ENDIF
			ENDIF
		ELSE
			// YWvH / Y coordinate match?
			LD	A,E
			IF	A == C
				CALL	SW_API_GetSnakeDir
				// is2H / Is the direction 2?
				IF	A == 2
					// GTEɂH / Is it to the right of the food?
					LD	A,D
					IF	A >= B
						CALL	common_turnRightSafety
					ELSE
						CALL	common_turnLeftSafety
					ENDIF
				// is8H / Is the direction 8?
				ELSEIF	A == 8
					// GTEɂH / Is it to the right of the food?
					LD	A,D
					IF	A >= B
						CALL	common_turnLeftSafety
					ELSE
						CALL	common_turnRightSafety
					ENDIF
				ENDIF
			ENDIF
		ENDIF
	ENDIF
	RET

PREV_DIR:	DB	0	// Previous direction


// ẅ悪Sǂׂ / Check if one step ahead in the specified direction is safe
//(i)A: Direction (2, 4, 6 or 8, 0 is the current direction, 1 is left of the current, 3 is right of the current)
//(o)Carry flag: 1(Safe)A0(Not safe)
common_checkSafe:
	CALL	SW_API_GetSnakeAheadChar
	LD	A,D
	// AX^XNłȂH / Isn't it an asterisk?
	IF	A != 2AH
		LD	A,E
		// ǂH / Is it a wall?
		IF	A == 7
			AND	A	// L[tO𗎂Ƃ / Clear carry flag
			RET
		// ւ̓̂H / Is it body of snake?
		ELSEIF	A == 5
			AND	A	// L[tO𗎂Ƃ / Clear carry flag
			RET
		// c[H / Is it a wreckage?
		ELSEIF	A == 1
			// p[AbvłȂH / Not in power up?
			CALL	SW_API_GetSnakeState
			BIT	1,A
			IF	Z
				AND	A	// L[tO𗎂Ƃ / Clear carry flag
				RET
			ENDIF
		ENDIF
	ENDIF

	SCF	// L[tO𗧂Ă / Set carry flag
	RET


// SȂE֕] / Turn to the right if safe
//(o)Carry flag: 1(Turned)A0(Didn't turn)
common_turnRightSafety:
	LD	A,3
	CALL	common_checkSafe
	IF	C
		CALL	SW_API_SetSnakeDirR
		SCF	// L[tO𗧂Ă / Set carry flag
	ENDIF
	RET


// SȂ獶֕] / Turn to the left if safe
//(o)Carry flag: 1(Turned)A0(Didn't turn)
common_turnLeftSafety:
	LD	A,1
	CALL	common_checkSafe
	IF	C
		CALL	SW_API_SetSnakeDirL
		SCF	// L[tO𗧂Ă / Set carry flag
	ENDIF
	RET

	END

